<?php
/*
 * Plugin name: Grimlock Video
 * Plugin URI:  http://www.themosaurus.com
 * Description: Adds YouTube or Vimeo background videos for Grimlock Section widgets and Grimlock Hero.
 * Author:      Themosaurus
 * Author URI:  http://www.themosaurus.com
 * Version:     1.1.0
 * License:     GPL-2.0+
 * License URI: http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain: grimlock-video
 * Domain Path: /languages
 */

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

define( 'GRIMLOCK_VIDEO_VERSION',         '1.1.0' );
define( 'GRIMLOCK_VIDEO_PLUGIN_FILE',     __FILE__ );
define( 'GRIMLOCK_VIDEO_PLUGIN_DIR_PATH', plugin_dir_path( __FILE__ ) );
define( 'GRIMLOCK_VIDEO_PLUGIN_DIR_URL',  plugin_dir_url( __FILE__ ) );

// Initialize update checker
require 'libs/plugin-update-checker/plugin-update-checker.php';
Puc_v4_Factory::buildUpdateChecker(
	'http://files.themosaurus.com/grimlock-video/version.json',
	__FILE__,
	'grimlock-video'
);

/**
 * Load plugin.
 *
 * @since 1.0.0
 */
function grimlock_video_loaded() {
	require_once 'inc/class-grimlock-video.php';

	global $grimlock_video;
	$grimlock_video = new Grimlock_Video();

	do_action( 'grimlock_video_loaded' );
}
add_action( 'grimlock_loaded', 'grimlock_video_loaded' );

/**
 * Add support for Grimlock Hero.
 *
 * @since 1.0.5
 */
function grimlock_video_hero_loaded() {
	require_once 'inc/hero/class-grimlock-video-hero.php';

	global $grimlock_video_hero;
	$grimlock_video_hero = new Grimlock_Video_Hero();

	do_action( 'grimlock_video_hero_loaded' );
}
add_action( 'grimlock_hero_loaded', 'grimlock_video_hero_loaded' );
