<?php
// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * Class Grimlock_Video
 *
 * @author  themosaurus
 * @since   1.0.0
 * @package grimlock-video
 */
class Grimlock_Video {
	/**
	 * Setup class.
	 *
	 * @since 1.0.0
	 */
	public function __construct() {
		load_plugin_textdomain( 'grimlock-video', false, 'grimlock-video/languages' );

		add_action( 'wp_enqueue_scripts',          array( $this, 'enqueue_scripts' ), 10 );
		add_action( 'enqueue_block_editor_assets', array( $this, 'enqueue_scripts' ), 10 );

		// Initialize widgets.
		require_once GRIMLOCK_VIDEO_PLUGIN_DIR_PATH . 'inc/widget/fields/class-grimlock-video-section-widget-fields.php';

		// Initialize blocks.
		require_once GRIMLOCK_VIDEO_PLUGIN_DIR_PATH . 'inc/block/class-grimlock-video-section-block.php';

		// Initialize components.
		require_once GRIMLOCK_VIDEO_PLUGIN_DIR_PATH . 'inc/component/class-grimlock-video-section-component.php';

		global $grimlock;
		remove_action( 'grimlock_section', array( $grimlock, 'section' ), 10 );
		add_action( 'grimlock_section',    array( $this,     'section' ), 10, 1 );

	}

	/**
	 * Display the section component.
	 *
	 * @param array $args
	 * @since 1.0.0
	 */
	public function section( $args = array() ) {
		$component = new Grimlock_Video_Section_Component( apply_filters( 'grimlock_section_args', (array) $args ) );
		$component->render();
	}

	/**
	 * Enqueue scripts.
	 *
	 * @since 1.0.0
	 */
	public function enqueue_scripts() {
		wp_enqueue_style( 'grimlock-video', GRIMLOCK_VIDEO_PLUGIN_DIR_URL . 'assets/css/main.css', array(), GRIMLOCK_VIDEO_VERSION );

		wp_enqueue_script( 'youtube-iframe-api', 'https://www.youtube.com/iframe_api', array(), GRIMLOCK_VIDEO_VERSION, true );
		wp_enqueue_script( 'jquery.mb.YTPlayer', GRIMLOCK_VIDEO_PLUGIN_DIR_URL . 'assets/js/vendor/jquery.mb.YTPlayer.js', array( 'jquery' ), '3.2.9', true );
		wp_enqueue_script( 'jquery.mb.vimeo_player', GRIMLOCK_VIDEO_PLUGIN_DIR_URL . 'assets/js/vendor/jquery.mb.vimeo_player.js', array( 'jquery' ), '1.2.0', true );
		wp_enqueue_script( 'grimlock-video', GRIMLOCK_VIDEO_PLUGIN_DIR_URL . 'assets/js/main.js', array( 'jquery' ), GRIMLOCK_VIDEO_VERSION, true );
	}
}